// sudo apt-get update
// sudo apt-get install gcc
// sudo apt-get install libx11-dev
// gcc lv.c -o lv -lX11 -no-pie
// chmod ugo+x lv

#include <unistd.h>
#include <stdbool.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <signal.h>
#include <errno.h> 
#include <X11/Xlib.h> 
#include <X11/XKBlib.h>
#include <ctype.h>

 extern int errno; 
   char msg [256];
    int sdf; 
    int width, height, mx_width, mx_height, tmp, left=4;
   Font font;
Display *d; 
 Window w;
     GC gc;
 XEvent e; 

bool lv_max_start=false, bk_on=false, caps=false;

#define _MAX_PATH 1024

FILE *lv_file;

char seek [16];

char g_title [100];

int lv_bw=0, lv_cap;
int lv_range0=32;
int lv_range1=1024*8;
int lv_range2=512;
int lv_range=512;//lv_range2;
#define lv_range_mx 1024*8
unsigned long lv_size;
int lv_lines0=32;
int lv_lines=32;//lv_lines0;
int lv_lines1=128;
int lv_hilight=0;
int lv_cols0=99;//89;
int lv_cols=99;//89;//lv_cols0;
int lv_cols1=512;
#define lv_cols_mx 512+1
char lv_txt [128] [1024*8];
int lv_shift=0;
int lv_len [128];
unsigned long lv_end;
unsigned long lv_pos=0;
unsigned long lv_pos1=0;
unsigned long lv_pos1up=0;
unsigned long lv_pos30=0;
int lv_mode=0;
bool lv_cls=false, lv_init=false, lv_over=false, init_off=false, no_rest=false;

bool lv_capture=false, seek_once=false, seek_hl=false;
const unsigned int TIMER_CAPTURE=10;

int mx_len=2100000000, lv_sp;
bool too_long=false;

bool ctrl_key_l=false, ctrl_key_r=false,
     shift_key_l=false, shift_key_r=false, shift_key2=false, shift_key3=true;

int g_l=0;

char path [_MAX_PATH], path2 [_MAX_PATH], path3 [_MAX_PATH];
int path2_l=0, path3_l;

int lv_max=0, lv_h0=620, lv_h1=620, lv_h=620, lv_w0=900, lv_w=906;
int gFunsterStil;


int sx;
int sy;

int wx;
int wy;


char AppPath [_MAX_PATH];
char RootPath [_MAX_PATH];
int ap_l=0;

int down_off_pgdown_c,down_off_pgup_c;

int min_r_left, min_r_top;

int zDelta, g_i;
char dropFile [_MAX_PATH];
//HDROP hDropInfo;
bool skipConf=false;

// https://stackoverflow.com/questions/36188154/get-x11-window-caption-height
int caption ()
{
 Window root;
 Atom a, t;
 int s;
 long fg, bg;
 int f;
 unsigned long n, b;
 unsigned char *data = 0;
 long* extents;
 XEvent e;

 s = DefaultScreen(d);
 root = DefaultRootWindow(d);
 fg = BlackPixel(d, s);
 bg = WhitePixel(d, s);
 XSelectInput(d, w, ExposureMask|ButtonPressMask|KeyPressMask|PropertyChangeMask);

 XMapWindow(d,w);

 a = XInternAtom(d, "_NET_FRAME_EXTENTS", True); /* Property to check */

 /* Window manager doesn't set up the extents immediately */
 /* Wait until they are set up and there are 4 of them */
 while (XGetWindowProperty(d, w, a,
                           0, 4, False, AnyPropertyType,
                           &t, &f,
                           &n, &b, &data) != Success || n != 4 || b != 0) 
 {
  XNextEvent(d, &e);
 }

 /* OK got extents */
 extents = (long*) data;
//    printf ("Got frame extents: left %ld right %ld top %ld bottom %ld\n",
//            extents[0], extents[1], extents[2], extents[3]);

 int r=extents [2];
 if (!(r>10 && r<100))
  r=30;

 return r;
}

bool is_seek (int row)
{
 seek_hl=false;
 int i, i2, c, sl_seek=strlen (seek);

 if (sl_seek>0 && lv_len [row]-2-sl_seek+1>0)
 {
  for (i=0; i<lv_len [row]-2-sl_seek+1; i++)
  {
   c=0;
   for (i2=0; i2<sl_seek; i2++)
   {
    if (lv_txt [row] [i+i2]!=seek [i2])
     break;
    else
     c++;
   }
   if (c==sl_seek)
   {
    seek_hl=true;
    seek_once=true;
    break;
   }
  }
 }

 if (seek_hl)
  return true;
}

void save_conf()
{
 FILE *file;
 int i;
 char conf [1024];
 memset (conf, 0, 1024);

 if (lv_max==0)
 {
  Window root, child;
  root =  XRootWindow (d, 0);
  XTranslateCoordinates(d, w, root, 0, 0, &min_r_left, &min_r_top, &child);
  lv_cap=caption ();
  min_r_top-=lv_cap;
 }
 else
 {
  width=mx_width;
  height=mx_height;
 }

 int snap0 [10];
 char snap [39];
 memset (snap0, 0, 10);
 memset (snap, 32, 39);
 if (lv_file!=NULL && lv_size>0)
 {
  unsigned long i0=lv_pos-2, i1=lv_pos+2;
  int c=0;
  if ((int)i0<0)
   i0=0;
  if (i1>lv_size)
   i1=lv_size;
  while (c<5)
  {
   fseek (lv_file, i0, SEEK_SET);
   snap0 [c]=fgetc (lv_file);
   if (i0<i1)
    i0++;
   c++;
  }

  while (c<10)
  {
   i0=lv_pos/20*c+10;
   if (i0<0)
    i0=0;
   if (i0>lv_size)
    i0=lv_size;
   fseek (lv_file, i0, SEEK_SET);
   snap0 [c]=fgetc (lv_file);
   c++;
  }


  sprintf (snap, "%d %d %d %d %d %d %d %d %d %d ", snap0 [0], snap0 [1], snap0 [2], snap0 [3], snap0 [4], snap0 [5], snap0 [6], snap0 [7], snap0 [8], snap0 [9]);
 }

 sprintf (conf, "%d\n%d\n%d\n%d\n%d\n%d\n%d\n%lu\n%d\n%lu\n%s\n%s\n%s\n", lv_range, min_r_left, min_r_top, width, height, (lv_hilight!=0 ? 1 : 0), lv_max, lv_pos, lv_shift, lv_size, path2, snap, seek);

 char path [_MAX_PATH];
 memset (path, 0, _MAX_PATH);
 memcpy (path, AppPath, ap_l);
 strcat (path, "data/config.txt");

 file=fopen (path, "w");
 if (file!=NULL)
 {
  for (i=0; i<1024; i++)
  {
   if (conf [i]!=0)
    fputc (conf[i], file);
  }

  fclose (file);
 }

 if (lv_file!=NULL)
  fclose (lv_file);
}

void row_out (int row, char txt [lv_cols_mx])
{
 int i, i2, c, sl_seek=strlen (seek), bk_color, txt_color;

 is_seek (row);

 if (lv_hilight!=0 && row==lv_hilight)
 {
  txt_color=25*256*256+25*256+25;

  if (lv_capture)
   bk_color=0*256*256+155*256+0;
  else if (seek_hl)
   bk_color=170*256*256+100*256+255;
  else
   bk_color=170*256*256+170*256+255;
 }
 else
 {
  if (seek_hl)
  {
   txt_color=0*256*256+0*256+0;

   if (lv_capture)
    bk_color=0*256*256+155*256+0;
   else
    bk_color=242*256*256+170*256+25;
  }
  else
  {
   txt_color=255*256*256+255*256+255;

   if (lv_capture && !seek_once && lv_hilight==0)
    bk_color=0*256*256+155*256+0;
   else
    bk_color=0*256*256+0*256+0;
  }
 }

 if (bk_color!=0 || bk_on)
 {
  XSetForeground( d, gc, bk_color );
  XFillRectangle (d, w, gc, left, row*18, lv_cols*9, 18);
 }
 XSetForeground( d, gc, txt_color );
 XDrawString ( d, w, gc, left, 4+row*18+10, txt, lv_cols );

 if (seek_hl)
 {
  int txt_l=strlen (txt);
  char txt2 [lv_cols_mx];
  memset (txt2, 32, lv_cols_mx);

  for (i=0; i<txt_l; i++)
  {
   c=0;
   for (i2=0; i2<sl_seek; i2++)
   {
    if (i+lv_shift+i2>=lv_len [row]-2)
     break;
    else if (lv_txt [row] [i+lv_shift+i2]!=seek [i2])
     break;
    else
     c++;
   }
   if (c==sl_seek)
   {
    for (i2=0; i2<sl_seek; i2++)
     txt2 [i+i2]=txt [i+i2];
   }
  }

  if (lv_hilight!=0 && row==lv_hilight)
   txt_color=255*256*256+255*256+255;
  else
   txt_color=255*256*256+0*256+0;

  XSetForeground( d, gc, txt_color );
  XDrawString ( d, w, gc, left, 4+row*18+10, txt2, lv_cols );
 }
}

void quick_view ()
{
 int i, i2, c=0, l, l2;
 long pos=lv_pos, pos2=0;
 char txt [lv_range_mx], txt2 [lv_range_mx];
 bool n;

 if (lv_file!=NULL && lv_size>0)
 {
  i=0;
  lv_end=lv_cols;
  g_l=0;

  while (i<lv_lines)
  {
   c++;

   if (c>lv_range)
    i=lv_lines;

   memset (txt2, 0, lv_range_mx);

   fseek (lv_file, pos, SEEK_SET);
   fgets (txt2, lv_range, lv_file);

   pos2=ftell (lv_file)+1;

   if (pos+lv_range>=lv_size && (pos2-pos)<2)
   {
    if (lv_mode==2)
     pos2=lv_size;
   }

   if (lv_mode==2)
   {
    if ((pos2-1)>=lv_pos1up)
    {
     lv_pos=pos;//!!!
     break;
    }
   }
   else
   {
    l=0;
    memset (txt, ' ', lv_range_mx);
    for (i2=0; i2<lv_range; i2++)
    {
     l++;
     if (txt2 [i2]>31 || txt2 [i2]<0)
      txt [l-1]=txt2 [i2];
     else
      txt [l-1]=' ';

     if (txt2 [i2]==10 || txt2 [i2]==13 || pos+i2>=lv_size)// \r & \n
      break;
    }
    l+=1;
    g_l+=l;
   }

   pos=pos2-1;

   if (lv_mode==0 || lv_mode==1)
   {
    if (i==0)
     lv_pos1=pos;
    else if (i==(lv_lines-1))
     lv_pos30=pos;
   }

   if (lv_mode!=2)
   {
    l2=l-2;
    if (l2<0)
     l2=0;
    memcpy (lv_txt [i], txt, l2);
    lv_len [i]=l;
    if ((l-2)>lv_end)
     lv_end=l-2;

    i++;

    if (pos2>lv_size)
    {
     lv_over=true;
     i=lv_lines;
     lv_pos30=lv_size;
    }
    else
     lv_over=false;
   }
  }
 }
}

void row (int i)
{
 int i2;
 char txt3 [lv_cols_mx];
 memset (txt3, 0, lv_cols_mx);

 if (lv_shift!=0)
 {
  for (i2=0; i2<lv_cols; i2++)
  {
   if ((lv_shift+i2)>lv_len [i]-3)
    txt3 [i2]=' ';
   else
   {
    txt3 [i2]=lv_txt [i] [lv_shift+i2];

    if (txt3 [i2]<32 && txt3 [i2]>-1)
     txt3 [i2]=32;
   }
  }
 }
 else
 {
  for (i2=0; i2<lv_cols; i2++)
  {
   if (i2>lv_len [i]-3)
    txt3 [i2]=' ';
   else
   {
    txt3 [i2]=lv_txt [i] [i2];

    if (txt3 [i2]<32 && txt3 [i2]>-1)
     txt3 [i2]=32;
   }
  }
 }

 row_out (i, txt3);
}

void high_light ()
{
 if (lv_hilight==0)
  lv_hilight=lv_lines/2;// int (
 else
  lv_hilight=0;
}

void hl_out ()
{
 int t=lv_hilight;

 high_light ();

 if (lv_hilight>0)
  row (lv_hilight);
 else
 {
  bk_on=true;
  row (t);
  bk_on=false;
 }
}

void paint ()
{
 int i, i2, c;
 char txt3 [lv_cols_mx];

// XFlush(d);// !!!
// XFreeGC (d, gc);
// gc=XCreateGC (d, w, 0, 0);
// XSetFont( d, gc, font );

 XGetGeometry(d, w, (Window *)&tmp, &tmp, &tmp, &width, &height, &tmp, &tmp); 

 XSetForeground( d, gc, 0x000000 );
 XFillRectangle (d, w, gc, 0, 0, width, height);

 if (lv_mode!=3)
 {
  quick_view ();
  lv_mode=3;
 }

 for (i=0; i<lv_lines; i++)
  row (i);

 char txt0 [4];
 memset (txt0, 0, 3);
 char txt1 [4]={' ',' ',' ',' '};

 char txt2_0 [4];
 memset (txt2_0, 0, 3);
 char txt2_1 [4];

 char txt_sp [8];
 memset (txt_sp, 0, 8);

 char txt [lv_cols_mx];
 memset (txt, 0, lv_cols_mx);

 
 int per1, per2;

 if (lv_pos30>=lv_size || lv_size==0)
  per1=100;
 else
 {
  unsigned long t_1p=lv_size/100;
  per1=0;
  for (i=1; i<=100; i++)
  {
   if ((lv_pos+g_l)>=t_1p*i)
    per1=i;
   else
    break;
  }
 }

 sprintf (txt0, "%d", per1);

 if (per1<10)
  txt1 [2]=txt0 [0];
 else if (per1<100)
 {
  txt1 [1]=txt0 [0];
  txt1 [2]=txt0 [1];
 }
 else
 {
  txt1 [0]=txt0 [0];
  txt1 [1]=txt0 [1];
  txt1 [2]=txt0 [2];
 }

 if (lv_end>lv_cols)
  per2=(lv_shift+lv_cols)*100/lv_end;
 else
  per2=100;

 if (per2>100)
  per2=100;

 sprintf (txt2_0, "%d", per2);

 c=0;
 for (i=0; i<3; i++)
 {
  if (txt2_0 [2-i]>0)// int
   c++;
  else
   txt2_1 [i]=' ';
 }
 for (i=0; i<c; i++)
  txt2_1 [3-c+i]=txt2_0 [i];

 if (too_long)
  sprintf (txt_sp, " (%d%c)", lv_sp, 37);

 for (i=0; i<lv_cols1; i++)
 {
  if (i==0)
   txt [i]=' ';
  else if (i<4)
   txt [i]=txt1 [i-1];
  else if (i==4)
   txt [i]='%';
  else if (i>5 && i<9)
   txt [i]=txt2_1 [i-6];
  else if (i==9)
   txt [i]='%';
  else if (i>9 && i<10+strlen (txt_sp))
   txt [i]=txt_sp [i-10];
  else
   txt [i]=' ';
 }

 int color=15;
 for (i=0; i<18; i++)
 {
  if (i<9)
   color+=5;
  else if (i>9)
   color-=5;
  XSetForeground ( d, gc, color*2*256*256+color*256+0 );
  XDrawLine (d, w, gc, 4, height-4-18+i, width-4, height-4-18+i);//line right 
 }

 char txt4_1 [12]={'','','','','','','','',' ','','.'};
 char txt4_2 [12]={'2','0','1','1','-','1','9'};

 XSetForeground( d, gc, 0xffffff );
 XDrawString ( d, w, gc, width-215+25, height-8, txt4_1, strlen (txt4_1) );
 XDrawString ( d, w, gc, width-105+25, height-8, txt4_2, strlen (txt4_2) );
 XDrawString ( d, w, gc, 9, height-8, txt, strlen (txt) );

 char st [18];
 sprintf (st, "%s|", seek);

 XDrawString ( d, w, gc, width/2-(strlen (st)*9/2)-5*9, height-8, st, strlen (st) );
}

bool captured=false;
void capture ()
{
 FILE *file;
 int i, l;
 char txt [lv_range_mx];
 memset (txt, 0, lv_range_mx);
 unsigned long f_size=0;

 seek_once=false;
 for (i=0; i<lv_lines; i++)
  is_seek (i);

 char path [_MAX_PATH];
 memset (path, 0, _MAX_PATH);
 memcpy (path, path3, path3_l);
 strcat (path, "LogViewer.txt");
 if (captured==false)
 {
  file=fopen (path, "r");
  if (file!=NULL)
  {
   fseek (file, 0, SEEK_END);// seek to end of file
   f_size=ftell (file);// get current file pointer
   fclose (file);
  }
 }

 file=fopen (path, "a");
 if (file!=NULL)
 {
  if (captured==false)
  {
   char cap [200];
   memset (cap, 0, 200);

   strcat (cap, g_title);
   strcat (cap, " [");

   char dateStr [12];
   char timeStr [12];

   struct tm *tm_ptr;
   time_t the_time;
   (void)time(&the_time);
   tm_ptr = localtime (&the_time);// gmtime
   sprintf (dateStr, "%02d/%02d/%02d",
            tm_ptr->tm_mday, tm_ptr->tm_mon+1, tm_ptr->tm_year+1900);
   sprintf (timeStr, "%02d:%02d:%02d",
            tm_ptr->tm_hour, tm_ptr->tm_min, tm_ptr->tm_sec);

   strcat (cap, dateStr);
   strcat (cap, " ");
   strcat (cap, timeStr);
   strcat (cap, "]");

   if (f_size!=0)
   {
    fputc ('\n', file);
    fputc ('\n', file);
    fputc ('\n', file);
   }
   fputs (cap, file);
   fputc ('\n', file);
   fputc ('\n', file);
  }

  if (captured==true)
   fputc ('\n', file); 

  for (i=0; i<lv_lines; i++)
  {
   if ((lv_hilight!=0 && lv_hilight==i) || (seek_once && is_seek (i)) || (lv_hilight==0 && !seek_once))
   {
    memset (txt, 0, lv_range);
    l=lv_len [i]-2;
    if (l<0)
     l=0;
    memcpy (txt, lv_txt [i], l);
    fputs (txt, file);
    fputc ('\n', file);
   }
  }

  fclose (file);

  captured=true;

  paint ();
 }
}

bool lv_captured=false;
void capture_off (int sig)
{
 lv_captured=true;

 // https://stackoverflow.com/questions/10785491/how-to-allow-a-worker-thread-to-updata-an-x11-window
 XEvent exppp;
 exppp.type = Expose;
 exppp.xexpose.window = w;
 XSendEvent(d,w,False,ExposureMask,&exppp);
 XFlush(d);
}

bool view0=false, force_view=false;

void view_down ()
{
 if (lv_pos30>=lv_size && !force_view)
  return;

 lv_pos=lv_pos1;
 lv_mode=1;
 if (view0==false)
  paint ();
}

void view_up()
{
 if (lv_pos==0)
  return;

 int i=0;
 lv_mode=2;
 lv_pos1up=lv_pos;
 unsigned long t_lv_pos;

 unsigned long t_lv_range=lv_range;
 bool b_lv_range=false;

 for (i=0; i<2; i++)
 {
  if (lv_pos<=t_lv_range && b_lv_range==false)
  {
   t_lv_range=lv_pos;
   b_lv_range=true;
  }
  else if (b_lv_range==true)
  {
   lv_pos=0;
   lv_mode=1;
   quick_view ();
   lv_mode=3;

   paint ();

   break;
  }

  t_lv_pos=lv_pos-t_lv_range;

  if (i==1)
   t_lv_pos-=1;
  lv_pos=t_lv_pos;
  quick_view ();
  if (lv_pos!=t_lv_pos)
  {
   lv_mode=1;
   if (view0==false)
    paint ();

   break;
  }
  else
  {
   lv_pos=lv_pos1up;

   if (i==1)
    lv_mode=3;
  }
 }
}

void view_right()
{
 if (lv_shift<lv_end-lv_cols)
 {
  lv_shift++;
  lv_mode=3;
  paint ();
 }
}

void view_left()
{
 if (lv_shift>0)
 {
  lv_shift--;
  lv_mode=3;
  paint ();
 }
}

void view_end ()
{
 bool rw=true;

 if (lv_hilight>0)
 {
  if (lv_shift==lv_len [lv_hilight]-2-lv_cols)
   rw=false;
  else if ((lv_len [lv_hilight]-2)>lv_cols)
   lv_shift=lv_len [lv_hilight]-2-lv_cols;
  else if (lv_shift!=0)
   lv_shift=0;
  else
   rw=false;
 }
 else if (lv_end>lv_cols && lv_shift!=lv_end-lv_cols)
  lv_shift=lv_end-lv_cols;
 else
  rw=false;

 if (rw==true)
 {
  lv_mode=3;
  paint ();
 }
}

void view_home ()
{
 if (lv_shift!=0)
 {
  lv_shift=0;
  lv_mode=3;
  paint ();
 }
}

void view_pg_up_ctrl()
{
 if (lv_pos==0)
  return;

 lv_pos=0;
 lv_mode=1;
 quick_view ();
 lv_mode=3;
 paint ();
}

void view_pg_up()
{
 if (lv_pos==0)
  return;

 bool shift_pos=false;

 if ((shift_key_l==true || shift_key_r==true) && shift_key2==false && shift_key3==true)
 {
  if (lv_pos<=lv_size/200)
  {
   lv_pos=0;
   lv_mode=1;
   quick_view ();
   lv_mode=3;

   paint ();
  }
  else
  {
   lv_pos=lv_pos30;

   lv_pos-=lv_size/200;

   view0=true;
   view_up ();
   view0=false;

   paint ();
  }
 }
 else if (lv_pos>0)
 {
  view0=true;
  int i=0;

  for (i=0; i<lv_lines; i++)
   view_up ();
 
  if (lv_mode==1)
   paint ();

  view0=false;
 }
}

void view_pg_down_ctrl ()
{
 if (lv_pos30!=lv_size)
 {
  lv_pos=lv_size-1;
  shift_key2=true;

  view0=true;
  view_pg_up ();
  quick_view ();

  for (int i=0; i<lv_lines; i++)
  {
   if (lv_pos30>=lv_size)
    break;

   view_down ();
   quick_view ();
  }

  view0=false;
  paint ();

  shift_key2=false;
 }
}

void view_pg_down()
{
 unsigned long pos=lv_pos;
 bool rw=true;

 if ((shift_key_l==true || shift_key_r==true) && shift_key3==true)
 {
  if (lv_pos+lv_size/200>=lv_size)
  {
   view_pg_down_ctrl ();
   rw=false;
  }
  else
  {
   lv_pos+=lv_size/200;

   shift_key2=true;
   view_pg_up ();
   shift_key2=false;
   rw=false;
  }
 }
 else if (lv_pos30!=lv_size)
  lv_pos=lv_pos30;
 else
  return;

 if (rw==true)
 {
  lv_mode=1;
  quick_view ();
  
  if (lv_over==false)
  {
   lv_mode=3;
   paint ();
  }
  else
  {
   lv_mode=1;
   lv_pos=pos;
   quick_view ();

   view0=true;
   for (int i=0; i<lv_lines; i++)
   {
    if (lv_pos30>=lv_size)
     break;

    view_down ();
    quick_view ();
   }
   view0=false;
   paint ();

   lv_over=false;
  }
 }
}

void view_max ()
{
 int i, t_hilight=lv_hilight, t_hilight2;

 XGetGeometry(d, w, (Window *)&tmp, &tmp, &tmp, &width, &height, &tmp, &tmp); 

 lv_hilight=0;
 high_light ();

 lv_cols=(width-4)/9;
 if (lv_cols>lv_cols1)
  lv_cols=lv_cols1;
 lv_lines=(height-12)/18-1;
 if (lv_lines>lv_lines1)
  lv_lines=lv_lines1;
 left=(width-lv_cols*9)/2;

 t_hilight2=lv_hilight;
 lv_hilight=0;
 high_light ();

 if (!lv_max_start && t_hilight)
 {
  view0=true;
  for (i=0; i<(lv_hilight-t_hilight2); i++)
   view_up ();
  view0=false;
 }
 lv_hilight=t_hilight;

 lv_mode=1;

 if (lv_hilight!=0)
 {
  lv_hilight=0;
  high_light ();
 }

 for (i=0; i<lv_lines; i++)
  memset (lv_txt [i], 0, lv_range_mx);

 lv_cls=true;
 paint ();

 lv_max=1;
}

void view_min ()
{
 if (lv_init==true)
  return;

 int i, t_hilight=lv_hilight, t_hilight2;

 XGetGeometry(d, w, (Window *)&tmp, &tmp, &tmp, &width, &height, &tmp, &tmp); 

 lv_cols=(width-4)/9;
 if (lv_cols>lv_cols1)
  lv_cols=lv_cols1;
 lv_lines=(height-12)/18-1;
 if (lv_lines>lv_lines1)
  lv_lines=lv_lines1;
 left=(width-lv_cols*9)/2;

 t_hilight2=lv_hilight;
 lv_hilight=0;
 high_light ();

 view0=true;
 force_view=true;
 for (i=0; i<(t_hilight2-lv_hilight); i++)
 {
  view_down ();
  quick_view ();
 }
 view0=false;
 force_view=false;
 lv_hilight=t_hilight;

 lv_mode=1;

 if (lv_hilight!=0)
 {
  lv_hilight=0;
  high_light ();
 }

 lv_cls=true;
 paint ();

 lv_max=0;
}

void seek_add (int add)
{
 bool shift=false;
 char addc [2];

 if (strlen (seek)>=16)
  return;

 unsigned n;
 XkbGetIndicatorState(d, XkbUseCoreKbd, &n);
 if (n & 1)
  shift=true;
 if (shift_key_r || shift_key_l)
 {
  if (shift)
   shift=false;
  else
   shift=true;
 }

 if (shift)
  add=toupper (add);
 else if (caps)
  add=tolower (add);

 char good_keys [256]={" `~)!@#$%^&*(-_=+[{]}\\|;:\'\",<.>/?*-+ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890"};
 bool good_key=false;
 for (int i=0; i<sizeof (good_keys); i++)
 {
  if (add==good_keys [i])
   good_key=true;
 }

 if (good_key)
 {
  sprintf (addc, "%c", add);
  strcat (seek, addc);

  paint ();
 }
}

void bs ()
{
 if (strlen (seek)>0)
 {
  seek [strlen (seek)-1]='\0';
  paint ();
 }
}


void main (int argc, char **argv)
{
 if( ( d = XOpenDisplay( getenv("DISPLAY" ) ) ) == NULL )
 {
  printf( "Can't connect X server: %s\n", strerror( errno ) ); 
  exit( 1 ); 
 } 
 sdf = DefaultScreen( d ); 

 Screen*  scrn = DefaultScreenOfDisplay(d);
 sx  = scrn->width;
 sy = scrn->height;

 wx=(int)((sx-(lv_w-4))/2);
 wy=(int)((sy-(lv_h+4))/2);

 int i, i1=0, i2=0, i3=0, i4=0, i5=0,
     i6=0, i7=0, i8=0, i9=0, i10=0, i11=0, i12=0, i13=0, s=0;

 char txt [_MAX_PATH];
 memset (txt, 0, _MAX_PATH);
 ssize_t size = readlink ("/proc/self/exe", txt, _MAX_PATH - 1);

 for (i=_MAX_PATH-1; i>=0 && ap_l==0; i--)
 {
  if (txt [i]=='/')
   ap_l=i+1;
 }

 for (i=0; i<ap_l; i++)
  AppPath [i]=txt [i];

 FILE *file;
 char conf [1024], conlv_wx [1024], conlv_wy [1024], conlv_range [1024],
      conlv_width [1024], conlv_height [1024], conlv_hilight [1024], conlv_max [1024],
      conlv_pos [1024], conlv_shift [1024], conlv_size [1024], conlv_path2 [1024],
      conlv_snap [1024], conlv_seek [1024];
 memset (conf, 0, 1024);
 memset (conlv_wx, 0, 1024);
 memset (conlv_wy, 0, 1024);
 memset (conlv_width, 0, 1024);
 memset (conlv_height, 0, 1024);
 memset (conlv_range, 0, 1024);
 memset (conlv_hilight, 0, 1024);
 memset (conlv_max, 0, 1024);
 memset (conlv_pos, 0, 1024);
 memset (conlv_shift, 0, 1024);
 memset (conlv_size, 0, 1024);
 memset (conlv_path2, 0, 1024);
 memset (conlv_snap, 0, 1024);
 memset (conlv_seek, 0, 1024);

 memset (path, 0, _MAX_PATH);

 memset (path2, 0, _MAX_PATH);
 memcpy (path, AppPath, ap_l);
 strcat (path, "data/config.txt");

 int c=0;

 if (argc>1)
  sprintf (dropFile, "%s", argv [1]);
 bool qt2=false;
 for (c=0; c<_MAX_PATH; c++)
 {
  if (dropFile [c]==34)
   qt2=true;
  else if (dropFile [c]==0)
   break;
 }

 bool file_exists=false;
 if (c>2)
 {
  if (qt2==true)
  {
   for (i=0; i<c-2; i++)
    path2 [i]=dropFile [i+1];
   path2_l=c-2;
  }
  else
  {
   for (i=0; i<c; i++)
    path2 [i]=dropFile [i];
   path2_l=c;
  }

  file=fopen (path2, "rb");
  if (file!=NULL)
  {
   file_exists=true;
   fclose (file);
  }
 }
 if (!file_exists)
 {
  memcpy (path2, AppPath, ap_l);
  strcat (path2, "data/readme.txt");
  path2_l=ap_l+15;
 }

 if (!skipConf)
  file=fopen (path, "r");
 else
  file=NULL;

 if (file!=NULL)
 {
  fread (conf, 1, 1024, file);
  fclose (file);
     
  for (i=0; i<1024; i++)
  {
   if (conf [i])
   {
    if(s==0)
    {
     if (conf [i]=='\n')
      s=1;
     else
     {
      conlv_range [i1]=conf [i];
      i1++;
     }
    }
    else if(s==1)
    {
     if (conf [i]=='\n')
      s=2;
     else
     {
      conlv_wx [i2]=conf [i];
      i2++;
     }
    }
    else if(s==2)
    {
     if (conf [i]=='\n')
      s=3;
     else
     {
      conlv_wy [i3]=conf [i];
      i3++;
     }
    }
    else if(s==3)
    {
     if (conf [i]=='\n')
      s=4;
     else
     {
      conlv_width [i4]=conf [i];
      i4++;
     }
    }
    else if(s==4)
    {
     if (conf [i]=='\n')
      s=5;
     else
     {
      conlv_height [i5]=conf [i];
      i5++;
     }
    }
    else if(s==5)
    {
     if (conf [i]=='\n')
      s=6;
     else
     {
      conlv_hilight [i6]=conf [i];
      i6++;
     }
    }
    else if (s==6)
    {
     if (conf [i]=='\n')
      s=7;
     else
     {
      conlv_max [i7]=conf [i];
      i7++;
     }
    }
    else if (s==7)
    {
     if (conf [i]=='\n')
      s=8;
     else
     {
      conlv_pos [i8]=conf [i];
      i8++;
     }
    }
    else if (s==8)
    {
     if (conf [i]=='\n')
      s=9;
     else
     {
      conlv_shift [i9]=conf [i];
      i9++;
     }
    }
    else if (s==9)
    {
     if (conf [i]=='\n')
      s=10;
     else
     {
      conlv_size [i10]=conf [i];

      i10++;
     }
    }
    else if (s==10)
    {
     if (conf [i]=='\n')
      s=11;
     else
     {
      conlv_path2 [i11]=conf [i];
      i11++;
     }
    }
    else if (s==11)
    {
     if (conf [i]=='\n')
      s=12;
     else
     {
      conlv_snap [i12]=conf [i];
      i12++;
     }
    }
    else if (s==12)
    {
     if (conf [i]=='\n')
      s=13;
     else
     {
      conlv_seek [i13]=conf [i];
      i13++;
     }
    }
   }
  }

  memset (seek, 0, 16);
  memcpy (seek, conlv_seek, 12);

  if (i1!=0)
   lv_range=atoi (conlv_range);
  if (lv_range<lv_range0 || lv_range>lv_range1)
   lv_range=lv_range2;// default

  int twx=0, twy=0;
  if (i2!=0)
   twx=atoi (conlv_wx);
  if (i3!=0)
   twy=atoi (conlv_wy);
  if (twx>0 && twx<sx-50 && twy>0 && twy<sy-50)
  {
   wx=twx;
   wy=twy;
  }

  min_r_left=wx;
  min_r_top=wy;

  if (i4!=0)
   lv_w=atoi (conlv_width);
  if (i5!=0)
   lv_h=atoi (conlv_height);

  if (i6!=0)
   lv_hilight=atoi (conlv_hilight);

  if (i7!=0)
   lv_max=atoi (conlv_max);
  if (lv_max!=0)
   lv_max=1;
  else
   lv_max=0;
 }

 char title0 [11]={'L', 'o', 'g', 'V', 'i', 'e', 'w', 'e', 'r', ':', ' '};
 char title1 [lv_cols_mx];
 char title [100];
 memset (title, 0, 100);
 memset (title1, 0, lv_cols_mx);
 for (c=path2_l-1; c>=0; c--)
  if (path2 [c]=='/')
   break;

 memset (path3, 0, _MAX_PATH);
 for (i=0; i<c+1; i++)
  path3 [i]=path2 [i];
 path3_l=c+1;

 for (i=c+1; i<path2_l; i++)
  title1 [i-c-1]=path2 [i];

 for (i=0; i<11; i++)
  title [i]=title0 [i];

 strcat (title, title1);
 strcat (g_title, title1);


 w=XCreateSimpleWindow ( d, RootWindow (d, sdf),    
                         wx, wy, lv_w, lv_h, 1, 
                         BlackPixel (d, sdf), WhitePixel (d, sdf) ); 
 XSelectInput (d, w, ExposureMask
                   | KeyPressMask
                   | KeyReleaseMask
                   | StructureNotifyMask);// | SubstructureRedirectMask 
 XMapWindow (d, w);                                 

/* create the Graphics Context */
 gc=XCreateGC (d, w, 0, 0);

 XChangeProperty( d, w,
      XInternAtom(d, "_NET_WM_NAME", False),
      XInternAtom(d, "UTF8_STRING", False),
      8, PropModeReplace, title,
      strlen (title));

 XMoveWindow (d, w, wx, wy);
 width=lv_w;
 height=lv_h;

 lv_file=fopen (path2, "rb");

 if (lv_file!=NULL)
 {
  fseek (lv_file, 0, SEEK_END);// seek to end of file
  if (!too_long)
  {
   lv_size=ftell (lv_file);// get current file pointer
   if (lv_size>mx_len)
   {
    lv_sp=mx_len/(lv_size/100);
    lv_size=mx_len;
    too_long=true;
   }
  }
  else
   lv_size=mx_len;
  if (lv_size/200<lv_range*lv_lines)
   shift_key3=false;

  if (i8!=0 && i10!=0 && i11!=0 && !skipConf)
  {
   bool p_pos=true;
   for (i=0; i<path2_l; i++)
   {
    if (path2 [i]!=conlv_path2 [i])
     p_pos=false;
   }
   if (p_pos==false)
   {
    p_pos=true;

    for (i=0; i<path2_l; i++)
    {
     if (path2 [i]=='/' || path2 [i]=='\\')
      break;
     if (path2 [path2_l-i]!=conlv_path2 [i9-i])
      p_pos=false;
    }
    if (lv_size!=atoi (conlv_size))
     p_pos=false;
   }

   if (p_pos==true)
   {
    if (atoi (conlv_size)>lv_size)
     p_pos=false;
   }

   if (p_pos==true)
   {
    unsigned long t_i0=atoi (conlv_pos)-2, t_i1=atoi (conlv_pos)+2;
    int t_int [10], t_int2, t_pos=0, t_i=0, t_c, t_c2=0, t_c3=0;
    char t_char [3];

    for (i=0; i<i12; i++)
    {
     if (conlv_snap [i]==' ')
     {
      memset (t_char, 0, 3);
      t_c=0;
      for (t_i=t_pos; t_i<i && t_c<3; t_i++)
      {
       t_char [t_c]=conlv_snap [t_i];
       t_c++;
      }
      t_pos=i+1;

      t_int [t_c2]=atoi (t_char);
      t_c2++;
     }
    }

    if ((int)t_i0<0)
     t_i0=0;

    if (t_i1>atoi (conlv_size))
     t_i1=atoi (conlv_size);

    while (t_c3<5)
    {
     fseek (lv_file, t_i0, SEEK_SET);
     t_int2=fgetc (lv_file);
     if (t_int2!=t_int [t_c3])
      p_pos=false;
     if (t_i0<t_i1)
      t_i0++;
     t_c3++;
    }

    while (t_c3<10)
    {
     t_i0=atoi (conlv_pos)/20*t_c3+10;
     if ((int)t_i0<0)
      t_i0=0;
     if (t_i0>atoi (conlv_size))
      t_i0=atoi (conlv_size);
     fseek (lv_file, t_i0, SEEK_SET);
     t_int2=fgetc (lv_file);
     if (t_int2!=t_int [t_c3])
      p_pos=false;
     t_c3++;
    }
   }
   else
   {
    fseek (lv_file, 0, SEEK_SET);
    fgetc (lv_file);
   }

   if (p_pos==true)
   {
    lv_pos=atoi (conlv_pos);
    lv_shift=atoi (conlv_shift);
   }
  }
 }

 font = XLoadFont( d, "-misc-fixed-medium-r-normal--18-120-100-100-c-90-koi8-r" );
 XSetFont( d, gc, font );

 lv_lines=(height-12)/18-1;
 if (lv_lines>lv_lines1)
  lv_lines=lv_lines1;

 if (lv_hilight!=0)
 {
  lv_hilight=0;
  high_light ();
 }

 lv_init=false;

 if (lv_max==1)
 {
  mx_width=lv_w;
  mx_height=lv_h;

  Atom wm_state  =  XInternAtom(d, "_NET_WM_STATE", False);
  Atom max_horz  =  XInternAtom(d, "_NET_WM_STATE_MAXIMIZED_HORZ", False);
  Atom max_vert  =  XInternAtom(d, "_NET_WM_STATE_MAXIMIZED_VERT", False);

  memset(&e, 0, sizeof(e));
  e.type = ClientMessage;
  e.xclient.window = w;
  e.xclient.message_type = wm_state;
  e.xclient.format = 32;
  e.xclient.data.l[0] = 1;//"_NET_WM_STATE_ADD";
  e.xclient.data.l[1] = max_horz;
  e.xclient.data.l[2] = max_vert;

  XSendEvent(d, DefaultRootWindow(d), False, SubstructureNotifyMask, &e);

  lv_max_start=true;
 }

 while (1)
 {
  if (lv_captured==true)
  {
   lv_captured=false;
   lv_capture=false;
   paint ();
  }

  XNextEvent( d, &e ); 

  if (e.type == ConfigureNotify)// || e.type == MapRequest)
  {
   bool wm_max=false;

   // https://www.linux.org.ru/forum/development/11335902
   Atom filter, net_wm_state, type, *atoms;
   int i, format, status;
   unsigned long nitems, bytes_after;
   unsigned char *prop;

   filter = XInternAtom(d, "_NET_WM_STATE_MAXIMIZED_HORZ", False);
   net_wm_state = XInternAtom(d, "_NET_WM_STATE", False);
   status = XGetWindowProperty(d, w, net_wm_state, 0, 256, False, AnyPropertyType,
                                &type, &format, &nitems, &bytes_after, &prop);
   atoms = (Atom *)prop;

   for (i = 0; i < nitems; i++)
   {
    if (atoms[i] == filter)
     wm_max=true;
   }

   XFree(prop);


   if (wm_max)
   {
    int t_width, t_height;
    XGetGeometry(d, w, (Window *)&tmp, &tmp, &tmp, &t_width, &t_height, &tmp, &tmp); 
    if (t_width>width)
    {
     mx_width=width;
     mx_height=height;
     view_max ();
    }
    else
     view_min ();
   }
   else if (!lv_init)
   {
    XGetGeometry(d, w, (Window *)&tmp, &tmp, &tmp, &width, &height, &tmp, &tmp); 
    lv_cols=(width-4)/9;
    if (lv_cols>lv_cols1)
     lv_cols=lv_cols1;
    lv_lines=(height-12)/18-1;
    if (lv_lines>lv_lines1)
    lv_lines=lv_lines1;
    left=(width-lv_cols*9)/2;
    lv_mode=1;
    paint ();
   }
  }
  else if( e.type == Expose )
  {
   if (lv_max_start)
   {
    view_max ();
    lv_max_start=false;
   }
   else if (!lv_init)
    paint ();
  }

  if (e.type==KeyPress)
  {
/*
   XSetForeground( d, gc, 0xffffff );
   sprintf (msg, "%d", e.xkey.keycode);
   XDrawString( d, w, gc, 50, 50, msg, strlen( msg ) ); 
*/
   if ( e.xkey.keycode == 22 )
    bs ();
   else if ( e.xkey.keycode == 116 || e.xkey.keycode==88)
    view_down ();
   else if ( e.xkey.keycode == 111 || e.xkey.keycode==80)
    view_up ();
   else if ( e.xkey.keycode == 114 || e.xkey.keycode==85)
    view_right ();
   else if ( e.xkey.keycode == 113 || e.xkey.keycode==83 )
    view_left ();
   else if ( e.xkey.keycode == 115 || e.xkey.keycode==87 )
    view_end ();
   else if ( e.xkey.keycode == 110 || e.xkey.keycode==79)
    view_home ();
   else if (e.xkey.keycode==117 || e.xkey.keycode==89)
   {
    if (ctrl_key_l==true || ctrl_key_r==true)
     view_pg_down_ctrl ();
    else
     view_pg_down ();
   }
   else if (e.xkey.keycode==112 || e.xkey.keycode==81)
   {
    if (ctrl_key_l==true || ctrl_key_r==true)
     view_pg_up_ctrl ();
    else
     view_pg_up ();
   }
   else if ( e.xkey.keycode == 37 )
    ctrl_key_l=true;
   else if ( e.xkey.keycode == 105 )
    ctrl_key_r=true;
   else if ( e.xkey.keycode == 50 )
    shift_key_l=true;
   else if ( e.xkey.keycode == 62 )
    shift_key_r=true;
   else if ( e.xkey.keycode == 36 )
    init_off=true;

   /* exit on ESC key press */
   else if ( e.xkey.keycode == 0x09 )
   {
    save_conf ();
    break;
   }

   else
   {
    int sys_keys [256]={23, 36, 37, 50, 62, 64, 66, 67, 68, 69, 70, 71,
                        72, 73, 74, 75, 76, 77, 78, 84, 90, 91, 95, 96,
                        104, 105, 108, 118, 119, 134, 135};
    bool sys_key=false;
    for (int i=0; i<sizeof (sys_keys); i++)
    {
     if (e.xkey.keycode==sys_keys [i])
      sys_key=true;
    }
    // https://stackoverflow.com/questions/9838385/replace-of-xkeycodetokeysym
    caps=e.xkey.state & ShiftMask ? 1 : 0;
    if (!sys_key)
     seek_add (XkbKeycodeToKeysym( d, e.xkey.keycode, 0, e.xkey.state & ShiftMask ? 1 : 0));
   }
  }
  else if (e.type == KeyRelease)
  {
   if ( e.xkey.keycode == 37 )
    ctrl_key_l=false;
   else if ( e.xkey.keycode == 105 )
    ctrl_key_r=false;
   else if ( e.xkey.keycode == 50 )
    shift_key_l=false;
   else if ( e.xkey.keycode == 62 )
    shift_key_r=false;
   else if ( e.xkey.keycode == 90 || e.xkey.keycode == 118 )
    hl_out ();
   else if ( e.xkey.keycode == 36 || e.xkey.keycode==104)
   {
    if (init_off)
     {
      lv_capture=true;
      capture ();

      // http://forums.codeguru.com/showthread.php?356101-How-to-use-timer-in-Unix
      struct itimerval tout_val;
      tout_val.it_interval.tv_sec = 0;
      tout_val.it_interval.tv_usec = 0;
      tout_val.it_value.tv_sec = 0;
      tout_val.it_value.tv_usec = 500000;
      setitimer(ITIMER_REAL, &tout_val,0);
      signal(SIGALRM,capture_off);
     }
   }
  }
 }

 fclose (lv_file);
 XFreeGC (d, gc);
 XDestroyWindow (d, w);
 XCloseDisplay( d );          
 exit (1);	
}
/*
   FILE *file;
   sprintf (msg, "%lu", lv_pos);
   file=fopen ("ok.txt", "w");
   if (file!=NULL)
   {
    fputs (msg, file);
    fclose (file);
   }
*/
